<?php

function mwd_insert() {
	global $wpdb;
	$mwd_forms = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`title` varchar(127) NOT NULL,
		`mail` varchar(128) NOT NULL,
		`form_front` longtext NOT NULL,
		`theme` int(11) NOT NULL,
		`list_id` varchar(255) NOT NULL,
		`type` varchar(100) NOT NULL,
		`counter` int(11) NOT NULL,
		`label_order` text NOT NULL,
		`label_order_current` text NOT NULL,
		`pagination` varchar(128) NOT NULL,
		`show_title` varchar(128) NOT NULL,
		`show_numbers` varchar(128) NOT NULL,
		`form_fields` longtext NOT NULL,
		`sortable` int(11) NOT NULL,
		`published` int(11) NOT NULL,
		`savedb` tinyint(4) NOT NULL,
		`requiredmark` varchar(20) NOT NULL,
		`double_optin` tinyint(4) NOT NULL,
		`welcome_email` tinyint(4) NOT NULL,
		`hide_after_signup` tinyint(4) NOT NULL,
		`update_subscriber` tinyint(4) NOT NULL,
		`replace_interest_groups` tinyint(4) NOT NULL,
		`delete_member` tinyint(4) NOT NULL,
		`send_goodbye` tinyint(4) NOT NULL,
		`send_notify` tinyint(4) NOT NULL,
		`subscribe_action` tinyint(4) NOT NULL,
		`merge_variables` text NOT NULL,
		`use_mailchimp_email` tinyint(4) NOT NULL,
		`from_mail` varchar(128) NOT NULL,
		`from_name` varchar(128) NOT NULL,
		`reply_to` varchar(128) NOT NULL,
		`mail_cc` varchar(128) NOT NULL,
		`mail_bcc` varchar(128) NOT NULL,
		`mail_subject` varchar(128) NOT NULL,
		`mail_mode` tinyint(4) NOT NULL,
		`mail_attachment` tinyint(4) NOT NULL,
		`mail_emptyfields` tinyint(4) NOT NULL,
		`script_mail` text NOT NULL,
		`mail_from_user` varchar(128) NOT NULL,
		`mail_from_name_user` varchar(128) NOT NULL,
		`reply_to_user` varchar(128) NOT NULL,
		`mail_subject_user` varchar(128) NOT NULL,
		`mail_subject_user_final` varchar(128) NOT NULL,
		`mail_cc_user` varchar(128) NOT NULL,
		`mail_bcc_user` varchar(128) NOT NULL,
		`mail_mode_user` tinyint(4) NOT NULL,
		`mail_attachment_user` tinyint(4) NOT NULL,
		`optin_confirmation_post_id` int(11) NOT NULL,
		`optin_confirmation_email` text NOT NULL,
		`final_welcome_email` text NOT NULL,
		`goodbye_email` text NOT NULL,
		`success_message` text NOT NULL,
		`unsubscribe_message` text NOT NULL,
		`gen_error_message` varchar(255) NOT NULL,
		`invalid_email_message` varchar(255) NOT NULL,
		`empty_submit_message` varchar(255) NOT NULL,
		`already_subscribed_message` varchar(255) NOT NULL,
		`not_subscribed_message` varchar(255) NOT NULL,
		`submit_text_type` tinyint(4) NOT NULL,
		`article_id` varchar(500) NOT NULL,
		`url` varchar(200) NOT NULL,
		`paypal_mode` int(2) NOT NULL,
		`checkout_mode` varchar(20) NOT NULL,
		`paypal_email` varchar(50) NOT NULL,
		`payment_currency` varchar(20) NOT NULL,
		`tax` float NOT NULL,
		`javascript` text NOT NULL,
		`condition` text NOT NULL,
		`header_title` varchar(255) NOT NULL,
		`header_description` text NOT NULL,
		`header_image_url` varchar(255) NOT NULL,
		`header_image_animation` varchar(200) NOT NULL,
		`header_hide_image` tinyint(4) NOT NULL DEFAULT '1',
		`required_message` varchar(255) NOT NULL,
		`groups` text NOT NULL,
		`unsubscribe_post_id` int(11) NOT NULL,
		`hide_labels` tinyint(4) NOT NULL,
		`update_message` varchar(255) NOT NULL,
		`mail_subject_unsubscribe` varchar(255) NOT NULL,
		PRIMARY KEY (`id`)
	) DEFAULT CHARSET=utf8";

	$wpdb->query($mwd_forms);

	$mwd_display_options = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_display_options` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`form_id` int(11) NOT NULL,
		`type` varchar(100) NOT NULL,
		`popover_animate_effect` varchar(255) NOT NULL,
		`popover_loading_delay` int(11) NOT NULL,
		`popover_frequency` int(4) NOT NULL,
		`topbar_position` tinyint(4) NOT NULL,
		`topbar_remain_top` tinyint(4) NOT NULL,
		`topbar_closing` tinyint(4) NOT NULL,
		`topbar_hide_duration` int(4) NOT NULL,
		`scrollbox_position` tinyint(4) NOT NULL,
		`scrollbox_trigger_point` float NOT NULL,
		`scrollbox_hide_duration` int(4) NOT NULL,
		`scrollbox_auto_hide` tinyint(4) NOT NULL,
		`scrollbox_closing` tinyint(4) NOT NULL DEFAULT '1',
		`scrollbox_minimize` tinyint(4) NOT NULL,
		`scrollbox_minimize_text` varchar(300) NOT NULL,
		`display_on` text NOT NULL,
		`posts_include` text NOT NULL,
		`pages_include` text NOT NULL,
		`display_on_categories` text NOT NULL,
		`current_categories` text NOT NULL,
		`scrollbox_loading_delay` tinyint(4) NOT NULL,
		`hide_mobile` tinyint(4) NOT NULL DEFAULT '1',
		`show_for_admin` tinyint(4) NOT NULL DEFAULT '1',
		PRIMARY KEY (`id`)
	)DEFAULT CHARSET=utf8;";
	$wpdb->query($mwd_display_options);

	$mwd_forms_submits = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms_submits` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`form_id` int(11) NOT NULL,
		`element_label` varchar(128) NOT NULL,
		`element_value` varchar(600) NOT NULL,
		`group_id` int(11) NOT NULL,
		`date` datetime NOT NULL,
		`ip` varchar(32) NOT NULL,
		`user_id_wd` int(11) NOT NULL,
		PRIMARY KEY (`id`)
	)DEFAULT CHARSET=utf8;";
	$wpdb->query($mwd_forms_submits);


	$mwd_forms_blocked = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms_blocked` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`ip` varchar(128) NOT NULL,
		PRIMARY KEY (`id`)
	) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";
	$wpdb->query($mwd_forms_blocked);

	$mwd_forms_views = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms_views` (
		`form_id` int(11) NOT NULL,
		`views` int(50) NOT NULL,
		PRIMARY KEY (`form_id`)
	) DEFAULT CHARSET=utf8;";
	$wpdb->query($mwd_forms_views);

	$mwd_forms_sessions = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms_sessions` (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`form_id` int(20) NOT NULL,
		`group_id` int(20) NOT NULL,
		`ip` varchar(20) NOT NULL,
		`ord_date` datetime NOT NULL,
		`ord_last_modified` datetime NOT NULL,
		`status` varchar(50) NOT NULL,
		`full_name` varchar(100) NOT NULL,
		`email` varchar(50) NOT NULL,
		`phone` varchar(50) NOT NULL,
		`mobile_phone` varchar(255) NOT NULL,
		`fax` varchar(255) NOT NULL,
		`address` varchar(300) NOT NULL,
		`paypal_info` text NOT NULL,
		`without_paypal_info` text NOT NULL,
		`ipn` varchar(20) NOT NULL,
		`checkout_method` varchar(20) NOT NULL,
		`tax` float NOT NULL,
		`shipping` float NOT NULL,
		`shipping_type` varchar(200) NOT NULL,
		`read` int(11) NOT NULL,
		`total` float NOT NULL,
		`currency` varchar(24) NOT NULL,
		PRIMARY KEY (`id`)
	) DEFAULT CHARSET=utf8;";
	$wpdb->query($mwd_forms_sessions);

	$mwd_forms_backup = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_forms_backup` (
		`backup_id` int(11) NOT NULL AUTO_INCREMENT,
		`cur` int(1) NOT NULL,
		`id` int(11) NOT NULL,
		`title` varchar(127) NOT NULL,
		`mail` varchar(128) NOT NULL,
		`form_front` longtext NOT NULL,
		`theme` int(11) NOT NULL,
		`list_id` varchar(255) NOT NULL,
		`type` varchar(100) NOT NULL,
		`counter` int(11) NOT NULL,
		`label_order` text NOT NULL,
		`label_order_current` text NOT NULL,
		`pagination` varchar(128) NOT NULL,
		`show_title` varchar(128) NOT NULL,
		`show_numbers` varchar(128) NOT NULL,
		`form_fields` longtext NOT NULL,
		`sortable` int(11) NOT NULL,
		`published` int(11) NOT NULL,
		`savedb` tinyint(4) NOT NULL,
		`requiredmark` varchar(20) NOT NULL,
		`double_optin` tinyint(4) NOT NULL,
		`welcome_email` tinyint(4) NOT NULL,
		`hide_after_signup` tinyint(4) NOT NULL,
		`update_subscriber` tinyint(4) NOT NULL,
		`replace_interest_groups` tinyint(4) NOT NULL,
		`delete_member` tinyint(4) NOT NULL,
		`send_goodbye` tinyint(4) NOT NULL,
		`send_notify` tinyint(4) NOT NULL,
		`subscribe_action` tinyint(4) NOT NULL,
		`merge_variables` text NOT NULL,
		`use_mailchimp_email` tinyint(4) NOT NULL,
		`from_mail` varchar(128) NOT NULL,
		`from_name` varchar(128) NOT NULL,
		`reply_to` varchar(128) NOT NULL,
		`mail_cc` varchar(128) NOT NULL,
		`mail_bcc` varchar(128) NOT NULL,
		`mail_subject` varchar(128) NOT NULL,
		`mail_mode` tinyint(4) NOT NULL,
		`mail_attachment` tinyint(4) NOT NULL,
		`mail_emptyfields` tinyint(4) NOT NULL,
		`script_mail` text NOT NULL,
		`mail_from_user` varchar(128) NOT NULL,
		`mail_from_name_user` varchar(128) NOT NULL,
		`reply_to_user` varchar(128) NOT NULL,
		`mail_subject_user` varchar(128) NOT NULL,
		`mail_subject_user_final` varchar(128) NOT NULL,
		`mail_cc_user` varchar(128) NOT NULL,
		`mail_bcc_user` varchar(128) NOT NULL,
		`mail_mode_user` tinyint(4) NOT NULL,
		`mail_attachment_user` tinyint(4) NOT NULL,
		`optin_confirmation_post_id` int(11) NOT NULL,
		`optin_confirmation_email` text NOT NULL,
		`final_welcome_email` text NOT NULL,
		`goodbye_email` text NOT NULL,
		`success_message` text NOT NULL,
		`unsubscribe_message` text NOT NULL,
		`gen_error_message` varchar(255) NOT NULL,
		`invalid_email_message` varchar(255) NOT NULL,
		`empty_submit_message` varchar(255) NOT NULL,
		`already_subscribed_message` varchar(255) NOT NULL,
		`not_subscribed_message` varchar(255) NOT NULL,
		`submit_text_type` tinyint(4) NOT NULL,
		`article_id` varchar(500) NOT NULL,
		`url` varchar(200) NOT NULL,
		`paypal_mode` int(2) NOT NULL,
		`checkout_mode` varchar(20) NOT NULL,
		`paypal_email` varchar(50) NOT NULL,
		`payment_currency` varchar(20) NOT NULL,
		`tax` float NOT NULL,
		`javascript` text NOT NULL,
		`condition` text NOT NULL,
		`header_title` varchar(255) NOT NULL,
		`header_description` text NOT NULL,
		`header_image_url` varchar(255) NOT NULL,
		`header_image_animation` varchar(200) NOT NULL,
		`header_hide_image` tinyint(4) NOT NULL DEFAULT '1',
		`required_message` varchar(255) NOT NULL,
		`groups` text NOT NULL,
		`unsubscribe_post_id` int(11) NOT NULL,
		`hide_labels` tinyint(4) NOT NULL,
		`update_message` varchar(255) NOT NULL,
		`mail_subject_unsubscribe` varchar(255) NOT NULL,
		PRIMARY KEY (`backup_id`)
	) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
    $wpdb->query($mwd_forms_backup);

	$mwd_themes = "CREATE TABLE IF NOT EXISTS `" . $wpdb->prefix . "mwd_themes` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`title` varchar(200) NOT NULL,
		`params` longtext NOT NULL,
		`default` tinyint(4) NOT NULL,
		PRIMARY KEY (`id`)
	) DEFAULT CHARSET=utf8;";
	$wpdb->query($mwd_themes);


	$wpdb->query('INSERT INTO `' . $wpdb->prefix . 'mwd_themes` (`title`, `params`, `default`) VALUES ("Theme 1", \'{"nonce_mwd":"fb467c8ea7","task":"","params":"","current_id":"1","default":"1","active_tab":"subscribe","title":"theme 1","GPFontFamily":"tahoma","AGPWidth":"100","AGPSPWidth":"30","AGPPadding":"","AGPMargin":"0 auto","AGPBorderColor":"#ffffff","AGPBorderType":"solid","AGPBorderWidth":"1","AGPBorderRadius":"0","AGPBoxShadow":"","HPAlign":"top","HPBGColor":"#b7b7b7","HPWidth":"100","HTPWidth":"40","HPPadding":"10px 0","HPMargin":"","HPTextAlign":"center","HPBorderColor":"#b7b7b7","HPBorderType":"solid","HPBorderWidth":"1","HPBorderRadius":"0","HTPFontSize":"24","HTPWeight":"normal","HTPColor":"#ffffff","HDPFontSize":"15","HDPColor":"#8b8b8b","HIPAlign":"top","HIPWidth":"80","HIPHeight":"","GPBGColor":"#ededed","GPFontSize":"16","GPFontWeight":"normal","GPWidth":"100","GTPWidth":"60","GPAlign":"center","GPBackground":"","GPBackgroundRepeat":"no-repeat","GPBGPosition1":"","GPBGPosition2":"","GPBGSize1":"","GPBGSize2":"","GPColor":"#959595","GPPadding":"10px","GPMargin":"","GPBorderColor":"#ffffff","GPBorderType":"solid","GPBorderWidth":"1","GPBorderRadius":"0","GPMLFontSize":"14","GPMLFontWeight":"normal","GPMLColor":"#b5b5b5","GPMLPadding":"0px 5px 0px 0px","GPMLMargin":"0px","SEPBGColor":"#ededed","SEPPadding":"","SEPMargin":"","COPPadding":"10px","COPMargin":"0px","FPWidth":"70","FPPadding":"15px 0 0 0","FPMargin":"0 auto","IPHeight":"26","IPFontSize":"14","IPFontWeight":"normal","IPBGColor":"#ffffff","IPColor":"#868686","IPPadding":"0px 5px","IPMargin":"0px","IPBorderTop":"top","IPBorderRight":"right","IPBorderBottom":"bottom","IPBorderLeft":"left","IPBorderColor":"#dfdfdf","IPBorderType":"solid","IPBorderWidth":"1","IPBorderRadius":"0","IPBoxShadow":"","SBPAppearance":"none","SBPBackground":"images/themes/drop-downs/2.png","SBPBGRepeat":"no-repeat","SBPBGPos1":"95%","SBPBGPos2":"50%","SBPBGSize1":"8%","SBPBGSize2":"32%","SCPBGColor":"#ffffff","SCPWidth":"16","SCPHeight":"16","SCPBorderTop":"top","SCPBorderRight":"right","SCPBorderBottom":"bottom","SCPBorderLeft":"left","SCPBorderColor":"#868686","SCPBorderType":"solid","SCPBorderWidth":"1","SCPMargin":"0px 3px","SCPBorderRadius":"15","SCPBoxShadow":"","SCCPBGColor":"#868686","SCCPWidth":"6","SCCPHeight":"6","SCCPMargin":"5","SCCPBorderRadius":"10","MCPBGColor":"#ffffff","MCPWidth":"16","MCPHeight":"16","MCPBorderTop":"top","MCPBorderRight":"right","MCPBorderBottom":"bottom","MCPBorderLeft":"left","MCPBorderColor":"#868686","MCPBorderType":"solid","MCPBorderWidth":"1","MCPMargin":"0px 3px","MCPBorderRadius":"0","MCPBoxShadow":"","MCCPBGColor":"","MCCPBackground":"images/themes/checkboxes/1.png","MCCPBGRepeat":"no-repeat","MCCPBGPos1":"","MCCPBGPos2":"","MCCPWidth":"16","MCCPHeight":"16","MCCPMargin":"0","MCCPBorderRadius":"0","SPAlign":"left","SPBGColor":"#e74c3c","SPWidth":"","SPHeight":"","SPFontSize":"16","SPFontWeight":"normal","SPColor":"#ffffff","SPPadding":"5px 8px","SPMargin":"0 15px 0 0","SPBorderTop":"top","SPBorderRight":"right","SPBorderBottom":"bottom","SPBorderLeft":"left","SPBorderColor":"#e74c3c","SPBorderType":"solid","SPBorderWidth":"1","SPBorderRadius":"0","SPBoxShadow":"","SHPBGColor":"#701e16","SHPColor":"#ffffff","SHPBorderTop":"top","SHPBorderRight":"right","SHPBorderBottom":"bottom","SHPBorderLeft":"left","SHPBorderColor":"#701e16","SHPBorderType":"solid","SHPBorderWidth":"1","BPBGColor":"#2d4d5f","BPWidth":"","BPHeight":"","BPFontSize":"16","BPFontWeight":"normal","BPColor":"#ffffff","BPPadding":"5px 8px","BPMargin":"0 15px 0 0","BPBorderTop":"top","BPBorderRight":"right","BPBorderBottom":"bottom","BPBorderLeft":"left","BPBorderColor":"#2d4d5f","BPBorderType":"solid","BPBorderWidth":"1","BPBorderRadius":"0","BPBoxShadow":"","BHPBGColor":"#5a7784","BHPColor":"#ffffff","BHPBorderTop":"top","BHPBorderRight":"right","BHPBorderBottom":"bottom","BHPBorderLeft":"left","BHPBorderColor":"#5a7784","BHPBorderType":"solid","BHPBorderWidth":"1","PSAPBGColor":"#e74c3c","PSAPFontSize":"16","PSAPFontWeight":"normal","PSAPColor":"#ffffff","PSAPHeight":"","PSAPLineHeight":"","PSAPPadding":"8px","PSAPMargin":"0 0 4px 0 ","PSAPBorderTop":"top","PSAPBorderRight":"right","PSAPBorderBottom":"bottom","PSAPBorderLeft":"left","PSAPBorderColor":"#e74c3c","PSAPBorderType":"solid","PSAPBorderWidth":"2","PSAPBorderRadius":"3","PSDPBGColor":"#a5a5a5","PSDPFontSize":"16","PSDPFontWeight":"normal","PSDPColor":"#ffffff","PSDPHeight":"","PSDPLineHeight":"","PSDPPadding":"4px 6px","PSDPMargin":"0 0 0 -3px","PSDPBorderTop":"top","PSDPBorderRight":"right","PSDPBorderBottom":"bottom","PSDPBorderLeft":"left","PSDPBorderColor":"#a3a3a3","PSDPBorderType":"solid","PSDPBorderWidth":"2","PSDPBorderRadius":"3","PSAPAlign":"right","PSAPWidth":"","PPAPWidth":"100%","NBPBGColor":"","NBPWidth":"","NBPHeight":"","NBPLineHeight":"","NBPColor":"#e74c3c","NBPPadding":"4px 10px","NBPMargin":"0px","NBPBorderColor":"#777777","NBPBorderType":"solid","NBPBorderWidth":"1","NBPBorderRadius":"0","NBPBoxShadow":"","NBHPBGColor":"","NBHPColor":"#2d4d5f","NBHPBorderColor":"#787878","NBHPBorderType":"solid","NBHPBorderWidth":"1","PBPBGColor":"","PBPWidth":"100","PBPHeight":"","PBPLineHeight":"","PBPColor":"#9c9c9c","PBPPadding":"","PBPMargin":"0px","PBPBorderColor":"#777777","PBPBorderType":"solid","PBPBorderWidth":"1","PBPBorderRadius":"0","PBPBoxShadow":"","PBHPBGColor":"","PBHPColor":"#2d4d5f","PBHPBorderColor":"#787878","PBHPBorderType":"solid","PBHPBorderWidth":"1","CBPPosition":"absolute","CBPTop":"10px","CBPRight":"10px","CBPBottom":"","CBPLeft":"","CBPBGColor":"","CBPFontSize":"22","CBPFontWeight":"normal","CBPColor":"#777777","CBPPadding":"0px","CBPMargin":"0px","CBPBorderColor":"#ffffff","CBPBorderType":"solid","CBPBorderWidth":"1","CBPBorderRadius":"0","CBHPBGColor":"","CBHPColor":"#e74c3c","CBHPBorderColor":"#737373","CBHPBorderType":"solid","CBHPBorderWidth":"1","MBPBGColor":"#b7b7b7","MBPFontSize":"17","MBPFontWeight":"normal","MBPColor":"#ffffff","MBPTextAlign":"center","MBPPadding":"10px","MBPMargin":"","MBPBorderTop":"top","MBPBorderRight":"right","MBPBorderBottom":"bottom","MBPBorderLeft":"left","MBPBorderColor":"#8f8f8f","MBPBorderType":"solid","MBPBorderWidth":"2","MBPBorderRadius":"0","MBHPBGColor":"#ffffff","MBHPColor":"#8f8f8f","MBHPBorderTop":"top","MBHPBorderRight":"right","MBHPBorderBottom":"bottom","MBHPBorderLeft":"left","MBHPBorderColor":"#8f8f8f","MBHPBorderType":"solid","MBHPBorderWidth":"2","OPDeInputColor":"#afafaf","OPFontStyle":"normal","OPRColor":"#ff1313","OPDPIcon":"images/themes/date-pickers/2.png","OPDPRepeat":"no-repeat","OPDPPos1":"0%","OPDPPos2":"10%","OPDPMargin":"3px 0 0 -23px","OPFBgUrl":"images/themes/file-uploads/2.png","OPFBGRepeat":"no-repeat","OPFPos1":"0%","OPFPos2":"10%","OPGWidth":"100","CUPCSS":""}\', 1);');
	
	return;
}
?>
